<template>
  <!-- NOTIFICATIONS -->
  <vs-dropdown vs-custom-content vs-trigger-click class="cursor-pointer">
    <feather-icon
      icon="BellIcon"
      class="cursor-pointer mt-1 sm:mr-6 mr-2"
      :badge="unreadNotifications.length"
    />

    <vs-dropdown-menu
      class="notification-dropdown dropdown-custom vx-navbar-dropdown"
    >
      <div class="notification-top text-center p-5 bg-primary text-white">
        <h3 class="text-white">{{ unreadNotifications.length }}</h3>
        <p class="opacity-75">Thông báo mới</p>
      </div>

      <VuePerfectScrollbar
        ref="mainSidebarPs"
        class="scroll-area--nofications-dropdown p-0 mb-10"
        :settings="settings"
        :key="$vs.rtl"
      >
        <ul class="bordered-items">
          <li
            v-for="ntf in unreadNotifications"
            :key="ntf.index"
            class="flex justify-between px-4 py-4 notification cursor-pointer"
          >
            <div class="flex items-start">
              <feather-icon
                :icon="ntf.icon"
                :svgClasses="[
                  `text-${ntf.category}`,
                  'stroke-current mr-1 h-6 w-6'
                ]"
              ></feather-icon>
              <div class="mx-2">
                <span
                  class="font-medium block notification-title"
                  :class="[`text-${ntf.category}`]"
                  >{{ ntf.title }}</span
                >
                <small>{{ ntf.msg }}</small>
              </div>
            </div>
            <small class="mt-1 whitespace-no-wrap">{{
              elapsedTime(ntf.time)
            }}</small>
          </li>
        </ul>
      </VuePerfectScrollbar>

      <div
        class="
        checkout-footer
        fixed
        bottom-0
        rounded-b-lg
        text-primary
        w-full
        p-2
        font-semibold
        text-center
        border
        border-b-0
        border-l-0
        border-r-0
        border-solid
        d-theme-border-grey-light
        cursor-pointer"
      >
        <span>Xem tất cả thông báo</span>
      </div>
    </vs-dropdown-menu>
  </vs-dropdown>
</template>

<script>
import VuePerfectScrollbar from "vue-perfect-scrollbar";

export default {
  components: {
    VuePerfectScrollbar
  },
  data() {
    return {
      unreadNotifications: [
        {
          index: 0,
          title: "Chào mừng Joe! 😃",
          msg: "Thật tuyệt khi có bạn online. Thưởng thức Totodo :)",
          icon: "MessageSquareIcon",
          time: this.randomDate({ sec: 10 }),
          category: "primary"
        },
        {
          index: 1,
          title: "Hi Joe, cùng xem lại 1 tháng của bạn 🎈",
          msg:
            "Bạn đã chạy bộ tổng cộng 10km trong vòng 1 tháng. Nỗ lực nhiều hơn để đạt phần thưởng nhé!",
          icon: "MessageSquareIcon",
          time: this.randomDate({ sec: 40 }),
          category: "primary",
          image:
            "https://images-na.ssl-images-amazon.com/images/I/41Olahra45L._AC_.jpg"
        },
        {
          index: 2,
          title: "Nhận phần thưởng 🎊 🎁 🎉",
          msg: "Bạn đã hoàn thành mục tiêu đạt 850 điểm TOIEC",
          icon: "PackageIcon",
          time: this.randomDate({ min: 1 }),
          category: "success",
          image:
            "https://static1.srcdn.com/wordpress/wp-content/uploads/2020/11/Apple-iPhone-12-Pro-Max-Holiday-BG.jpg"
        },
        {
          index: 3,
          title: "Nộp báo cáo cho sếp 🎯",
          msg: "Bạn cần hoàn thành ngay hôm nay!",
          icon: "MailIcon",
          time: this.randomDate({ min: 6 }),
          category: "primary"
        },
        {
          index: 4,
          title: "Meeting với team 🌂",
          msg: "Bạn có công việc cần thực hiện vào ngày mai",
          icon: "CalendarIcon",
          time: this.randomDate({ hr: 2 }),
          category: "warning"
        },
        {
          index: 5,
          title: "Đi siêu thị 🛒",
          msg: "Bạn đã bỏ lỡ 1 công việc hết hạn vào ngày hôm qua",
          icon: "AlertOctagonIcon",
          time: this.randomDate({ hr: 2 }),
          category: "danger"
        }
      ],
      settings: {
        maxScrollbarLength: 60,
        wheelSpeed: 0.6
      }
    };
  },
  methods: {
    elapsedTime(startTime) {
      let x = new Date(startTime);
      let now = new Date();
      var timeDiff = now - x;
      timeDiff /= 1000;

      var seconds = Math.round(timeDiff);
      timeDiff = Math.floor(timeDiff / 60);

      var minutes = Math.round(timeDiff % 60);
      timeDiff = Math.floor(timeDiff / 60);

      var hours = Math.round(timeDiff % 24);
      timeDiff = Math.floor(timeDiff / 24);

      var days = Math.round(timeDiff % 365);
      timeDiff = Math.floor(timeDiff / 365);

      var years = timeDiff;

      if (years > 0) {
        return years + (years > 1 ? " Năm " : " Năm ") + "trước";
      } else if (days > 0) {
        return days + (days > 1 ? " Ngày " : " Ngày ") + "trước";
      } else if (hours > 0) {
        return hours + (hours > 1 ? " Giờ " : " Giờ ") + "trước";
      } else if (minutes > 0) {
        return minutes + (minutes > 1 ? " Phút " : " Phút ") + "trước";
      } else if (seconds > 0) {
        return seconds + (seconds > 1 ? " giây trước" : "ngay bây giờ");
      }

      return "Ngay Bây Giờ";
    },
    // Method for creating dummy notification time
    randomDate({ hr, min, sec }) {
      let date = new Date();

      if (hr) date.setHours(date.getHours() - hr);
      if (min) date.setMinutes(date.getMinutes() - min);
      if (sec) date.setSeconds(date.getSeconds() - sec);

      return date;
    }
  }
};
</script>
